/*
EntryPoints

## Overview  EntryPoint is one of the ways to start interaction flow. It can be represented as QR code, link (https://slace.me/... URL) or NFC tag.  ## Data  EntryPoints contain two types of data:   - **static** - *\"internal\" data storage which can be updated only via editing the EntryPoint* (directly or via Interaction) - **dynamic** - *public data which can be altered also via query parameters of the EP link. Should NOT be used for secrets or critical data* because it can be overwritten by the end user.  Both data containers are copied to transaction created when EntryPoint is entered. This data is used primarily for personalization or flow control of the Interaction.  ## EP Batches  EntryPoints can be batch-created (superadmin feature) and then [assigned](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx) to specific Interactions.  > EntryPoints in a batch have random hashes but it's possible to mass-create EPs using the assignment feature (only superadmins). If a value from **Link hash** column is not found it will be auto-created. This allows to create EntryPoints following different hash pattern (e.g. with common prefix).  EntryPoints are re-assignable meaning that they can be re-used for other Interactions even in another Channel or Organization by another [assignment import](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx).  ## Redirects  There is a special type of EntryPoint which does not start a SLACE Interaction but redirects to a configured URL.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package entrypoints

import (
	"encoding/json"
	"time"
)

// checks if the AdminEntryPoint type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AdminEntryPoint{}

// AdminEntryPoint struct for AdminEntryPoint
type AdminEntryPoint struct {
	Id string `json:"id"`
	Type AdminEntryPointType `json:"type"`
	OrganizationId *string `json:"organization_id,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
	InteractionId *string `json:"interaction_id,omitempty"`
	MessageLinkHash *string `json:"message_link_hash,omitempty"`
	OrderedBatchId *string `json:"ordered_batch_id,omitempty"`
	Url *string `json:"url,omitempty"`
	UrlHash *string `json:"url_hash,omitempty"`
	ExpiredUrl *string `json:"expired_url,omitempty"`
	Ttl int32 `json:"ttl"`
	Data *map[string]string `json:"data,omitempty"`
	Params *map[string]string `json:"params,omitempty"`
	CreatedAt time.Time `json:"created_at"`
	// Any text without '.' characters. Preferred over interaction_id if keeping the reference to the latest version of interaction is required.
	CustomerExperienceId *string `json:"customer_experience_id,omitempty"`
}

// NewAdminEntryPoint instantiates a new AdminEntryPoint object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAdminEntryPoint(id string, type_ AdminEntryPointType, ttl int32, createdAt time.Time) *AdminEntryPoint {
	this := AdminEntryPoint{}
	this.Id = id
	this.Type = type_
	this.Ttl = ttl
	this.CreatedAt = createdAt
	return &this
}

// NewAdminEntryPointWithDefaults instantiates a new AdminEntryPoint object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAdminEntryPointWithDefaults() *AdminEntryPoint {
	this := AdminEntryPoint{}
	return &this
}

// GetId returns the Id field value
func (o *AdminEntryPoint) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *AdminEntryPoint) SetId(v string) {
	o.Id = v
}

// GetType returns the Type field value
func (o *AdminEntryPoint) GetType() AdminEntryPointType {
	if o == nil {
		var ret AdminEntryPointType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetTypeOk() (*AdminEntryPointType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *AdminEntryPoint) SetType(v AdminEntryPointType) {
	o.Type = v
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *AdminEntryPoint) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *AdminEntryPoint) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *AdminEntryPoint) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *AdminEntryPoint) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *AdminEntryPoint) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *AdminEntryPoint) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *AdminEntryPoint) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *AdminEntryPoint) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *AdminEntryPoint) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetMessageLinkHash returns the MessageLinkHash field value if set, zero value otherwise.
func (o *AdminEntryPoint) GetMessageLinkHash() string {
	if o == nil || IsNil(o.MessageLinkHash) {
		var ret string
		return ret
	}
	return *o.MessageLinkHash
}

// GetMessageLinkHashOk returns a tuple with the MessageLinkHash field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetMessageLinkHashOk() (*string, bool) {
	if o == nil || IsNil(o.MessageLinkHash) {
		return nil, false
	}
	return o.MessageLinkHash, true
}

// HasMessageLinkHash returns a boolean if a field has been set.
func (o *AdminEntryPoint) HasMessageLinkHash() bool {
	if o != nil && !IsNil(o.MessageLinkHash) {
		return true
	}

	return false
}

// SetMessageLinkHash gets a reference to the given string and assigns it to the MessageLinkHash field.
func (o *AdminEntryPoint) SetMessageLinkHash(v string) {
	o.MessageLinkHash = &v
}

// GetOrderedBatchId returns the OrderedBatchId field value if set, zero value otherwise.
func (o *AdminEntryPoint) GetOrderedBatchId() string {
	if o == nil || IsNil(o.OrderedBatchId) {
		var ret string
		return ret
	}
	return *o.OrderedBatchId
}

// GetOrderedBatchIdOk returns a tuple with the OrderedBatchId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetOrderedBatchIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrderedBatchId) {
		return nil, false
	}
	return o.OrderedBatchId, true
}

// HasOrderedBatchId returns a boolean if a field has been set.
func (o *AdminEntryPoint) HasOrderedBatchId() bool {
	if o != nil && !IsNil(o.OrderedBatchId) {
		return true
	}

	return false
}

// SetOrderedBatchId gets a reference to the given string and assigns it to the OrderedBatchId field.
func (o *AdminEntryPoint) SetOrderedBatchId(v string) {
	o.OrderedBatchId = &v
}

// GetUrl returns the Url field value if set, zero value otherwise.
func (o *AdminEntryPoint) GetUrl() string {
	if o == nil || IsNil(o.Url) {
		var ret string
		return ret
	}
	return *o.Url
}

// GetUrlOk returns a tuple with the Url field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetUrlOk() (*string, bool) {
	if o == nil || IsNil(o.Url) {
		return nil, false
	}
	return o.Url, true
}

// HasUrl returns a boolean if a field has been set.
func (o *AdminEntryPoint) HasUrl() bool {
	if o != nil && !IsNil(o.Url) {
		return true
	}

	return false
}

// SetUrl gets a reference to the given string and assigns it to the Url field.
func (o *AdminEntryPoint) SetUrl(v string) {
	o.Url = &v
}

// GetUrlHash returns the UrlHash field value if set, zero value otherwise.
func (o *AdminEntryPoint) GetUrlHash() string {
	if o == nil || IsNil(o.UrlHash) {
		var ret string
		return ret
	}
	return *o.UrlHash
}

// GetUrlHashOk returns a tuple with the UrlHash field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetUrlHashOk() (*string, bool) {
	if o == nil || IsNil(o.UrlHash) {
		return nil, false
	}
	return o.UrlHash, true
}

// HasUrlHash returns a boolean if a field has been set.
func (o *AdminEntryPoint) HasUrlHash() bool {
	if o != nil && !IsNil(o.UrlHash) {
		return true
	}

	return false
}

// SetUrlHash gets a reference to the given string and assigns it to the UrlHash field.
func (o *AdminEntryPoint) SetUrlHash(v string) {
	o.UrlHash = &v
}

// GetExpiredUrl returns the ExpiredUrl field value if set, zero value otherwise.
func (o *AdminEntryPoint) GetExpiredUrl() string {
	if o == nil || IsNil(o.ExpiredUrl) {
		var ret string
		return ret
	}
	return *o.ExpiredUrl
}

// GetExpiredUrlOk returns a tuple with the ExpiredUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetExpiredUrlOk() (*string, bool) {
	if o == nil || IsNil(o.ExpiredUrl) {
		return nil, false
	}
	return o.ExpiredUrl, true
}

// HasExpiredUrl returns a boolean if a field has been set.
func (o *AdminEntryPoint) HasExpiredUrl() bool {
	if o != nil && !IsNil(o.ExpiredUrl) {
		return true
	}

	return false
}

// SetExpiredUrl gets a reference to the given string and assigns it to the ExpiredUrl field.
func (o *AdminEntryPoint) SetExpiredUrl(v string) {
	o.ExpiredUrl = &v
}

// GetTtl returns the Ttl field value
func (o *AdminEntryPoint) GetTtl() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Ttl
}

// GetTtlOk returns a tuple with the Ttl field value
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetTtlOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Ttl, true
}

// SetTtl sets field value
func (o *AdminEntryPoint) SetTtl(v int32) {
	o.Ttl = v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AdminEntryPoint) GetData() map[string]string {
	if o == nil || IsNil(o.Data) {
		var ret map[string]string
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetDataOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AdminEntryPoint) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given map[string]string and assigns it to the Data field.
func (o *AdminEntryPoint) SetData(v map[string]string) {
	o.Data = &v
}

// GetParams returns the Params field value if set, zero value otherwise.
func (o *AdminEntryPoint) GetParams() map[string]string {
	if o == nil || IsNil(o.Params) {
		var ret map[string]string
		return ret
	}
	return *o.Params
}

// GetParamsOk returns a tuple with the Params field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetParamsOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.Params) {
		return nil, false
	}
	return o.Params, true
}

// HasParams returns a boolean if a field has been set.
func (o *AdminEntryPoint) HasParams() bool {
	if o != nil && !IsNil(o.Params) {
		return true
	}

	return false
}

// SetParams gets a reference to the given map[string]string and assigns it to the Params field.
func (o *AdminEntryPoint) SetParams(v map[string]string) {
	o.Params = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *AdminEntryPoint) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *AdminEntryPoint) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetCustomerExperienceId returns the CustomerExperienceId field value if set, zero value otherwise.
func (o *AdminEntryPoint) GetCustomerExperienceId() string {
	if o == nil || IsNil(o.CustomerExperienceId) {
		var ret string
		return ret
	}
	return *o.CustomerExperienceId
}

// GetCustomerExperienceIdOk returns a tuple with the CustomerExperienceId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AdminEntryPoint) GetCustomerExperienceIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerExperienceId) {
		return nil, false
	}
	return o.CustomerExperienceId, true
}

// HasCustomerExperienceId returns a boolean if a field has been set.
func (o *AdminEntryPoint) HasCustomerExperienceId() bool {
	if o != nil && !IsNil(o.CustomerExperienceId) {
		return true
	}

	return false
}

// SetCustomerExperienceId gets a reference to the given string and assigns it to the CustomerExperienceId field.
func (o *AdminEntryPoint) SetCustomerExperienceId(v string) {
	o.CustomerExperienceId = &v
}

func (o AdminEntryPoint) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AdminEntryPoint) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["type"] = o.Type
	if !IsNil(o.OrganizationId) {
		toSerialize["organization_id"] = o.OrganizationId
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.MessageLinkHash) {
		toSerialize["message_link_hash"] = o.MessageLinkHash
	}
	if !IsNil(o.OrderedBatchId) {
		toSerialize["ordered_batch_id"] = o.OrderedBatchId
	}
	if !IsNil(o.Url) {
		toSerialize["url"] = o.Url
	}
	if !IsNil(o.UrlHash) {
		toSerialize["url_hash"] = o.UrlHash
	}
	if !IsNil(o.ExpiredUrl) {
		toSerialize["expired_url"] = o.ExpiredUrl
	}
	toSerialize["ttl"] = o.Ttl
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	if !IsNil(o.Params) {
		toSerialize["params"] = o.Params
	}
	toSerialize["created_at"] = o.CreatedAt
	if !IsNil(o.CustomerExperienceId) {
		toSerialize["customer_experience_id"] = o.CustomerExperienceId
	}
	return toSerialize, nil
}

type NullableAdminEntryPoint struct {
	value *AdminEntryPoint
	isSet bool
}

func (v NullableAdminEntryPoint) Get() *AdminEntryPoint {
	return v.value
}

func (v *NullableAdminEntryPoint) Set(val *AdminEntryPoint) {
	v.value = val
	v.isSet = true
}

func (v NullableAdminEntryPoint) IsSet() bool {
	return v.isSet
}

func (v *NullableAdminEntryPoint) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAdminEntryPoint(val *AdminEntryPoint) *NullableAdminEntryPoint {
	return &NullableAdminEntryPoint{value: val, isSet: true}
}

func (v NullableAdminEntryPoint) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAdminEntryPoint) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


